## mcrl2 201007~rc1

=== CMakeLists.txt ===
# Authors: Frank Stappers and Aad Mathijssen
# Copyright: see the accompanying file COPYING or copy at
# https://svn.win.tue.nl/trac/MCRL2/browser/trunk/COPYING
#
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)

# Set Warning

cmake_minimum_required (VERSION 2.6)
message(STATUS "CMAKE VERSION: ${CMAKE_VERSION}")
project (MCRL2)

option(MCRL2_BUILD_IN_SOURCE "Enable/Disable in-soucre tree development" OFF)
if(NOT MCRL2_BUILD_IN_SOURCE)
  if(${CMAKE_CURRENT_BINARY_DIR} EQUAL ${CMAKE_SOURCE_DIR})
    message(STATUS "=================================================================")
    message(STATUS "== WARNING: Do not upload the \"Makefile\" to the svn repository ==")
    message(STATUS "=================================================================")
    message(STATUS "")
    message(STATUS "To build in-source, set MCRL2_BUILD_IN_SOURCE=ON")
    message(STATUS "")
    message(FATAL_ERROR)
  endif(${CMAKE_CURRENT_BINARY_DIR} EQUAL ${CMAKE_SOURCE_DIR})
endif(NOT MCRL2_BUILD_IN_SOURCE)

# Commonly used options
# ---------------------
#
# The following lists some commonly used options to configure the build system
# (an option name following by (*) indicates the default option):
#
#   CMAKE_INSTALL_PREFIX = /usr/local(*) (any path can be used)
#   CMAKE_BUILD_TYPE     = None | Debug | Release(*) | RelwithDebInfo | MinSizeRel
#   MCRL2_USE_BOOST_INTERNAL   = ON(*) | OFF
#   BUILD_SHARED_LIBS    = ON    | OFF(*)
#   MCRL2_ENABLE_EXPERIMENTAL  = ON    | OFF(*)
#   MCRL2_ENABLE_DEPRECATED    = ON    | OFF(*)


# Note on adding definitions containing quotes (")
# ------------------------------------------------
#
# Compiler definitions can be added to CMake using the ADD_DEFINITIONS command
# or COMPILE_DEFINITIONS property. Be careful when adding a definition that
# contains quotes ("), as CMake cannot guarantee the generation of platform
# independent scripts. Typically these definitions are of the form FOO="bar",
# which can be added as follows:
#
#   add_definitions(-DFOO="bar")
#
# From this, CMake is able to generate correct Makefiles. However, CMake is
# not able to generate a correct Eclipse CDT4 project.
# 
# The solution that is currently employed is by adding compiler definitions
# that contain quotes using the set_source_files_properties command with the
# the COMPILE_DEFINITIONS property:
# 
#   set_source_files_properties(baz.cpp
#     PROPERTIES COMPILE_DEFINITIONS FOO="bar"
#   )
#
# This way, these compiler definitions are not included in the Eclipse CDT4
# project file, circumventing the problem.
#
# When this solution cannot be applied, there is another workaround: by quoting
# the entire compiling definition it is prevented from being incorporated in
# the Eclipse CDT4 project:
#
#   add_definitions(-D"FOO=\\"bar\\"")
#
# However, the best solution is to avoid the need for these quotes in the
# first place. This is mentioned as a disclaimer in the CMake 2.6 documentation
# for the COMPILER_DEFINITIONS property:
#
#   Dislaimer: Most native build tools have poor support for escaping
#   certain values. CMake has work-arounds for many cases but some values
#   may just not be possible to pass correctly. If a value does not seem to
#   be escaped correctly, do not attempt to work-around the problem by
#   adding escape sequences to the value. Your work-around may break in a
#   future version of CMake that has improved escape support. Instead
#   consider defining the macro in a (configured) header file. Then report
#   the limitation.
#
# The disclaimer with some additional information can be found here:
#
#   http://www.cmake.org/cmake/help/cmake2.6docs.html#prop_dir:COMPILE_DEFINITIONS
#

# Variables required for an additional build type "Maintainer"
 
set(CMAKE_CXX_FLAGS_MAINTAINER "-g -O0 -Wall -W -Wunused-variable -Wunused-parameter -Wunused-function -Wunused -Wno-system-headers -Woverloaded-virtual -Wwrite-strings -fprofile-arcs -ftest-coverage" CACHE STRING "Flags used by the C++ compiler during maintainer builds." FORCE)
set(CMAKE_C_FLAGS_MAINTAINER "-g -O0 -Wall -pedantic -W -fprofile-arcs -ftest-coverage" CACHE STRING "Flags used by the C compiler during maintainer builds." FORCE)
set(CMAKE_EXE_LINKER_FLAGS_MAINTAINER "-Wl,--warn-unresolved-symbols,--warn-once -fprofile-arcs -ftest-coverage" CACHE STRING "Flags used for linking binaries during maintainer builds." FORCE)
set(CMAKE_SHARED_LINKER_FLAGS_MAINTAINER "-Wl,--warn-unresolved-symbols,--warn-once -fprofile-arcs -ftest-coverage" CACHE STRING "Flags used by the shared libraries linker during maintainer builds." FORCE)
mark_as_advanced(
  CMAKE_CXX_FLAGS_MAINTAINER
  CMAKE_C_FLAGS_MAINTAINER
  CMAKE_EXE_LINKER_FLAGS_MAINTAINER
  CMAKE_SHARED_LINKER_FLAGS_MAINTAINER
)

##---------------------------------------------------
## Print compiler information 
##--------------------------------------------------- 

execute_process(COMMAND ${CMAKE_CXX_COMPILER} --version 
    OUTPUT_VARIABLE CXX_COMPILER_VERSION
    OUTPUT_STRIP_TRAILING_WHITESPACE
)

STRING(REGEX REPLACE "^([^\n]+).*" "\\1" CXX_COMPILER_VERSION "${CXX_COMPILER_VERSION}" )

message(STATUS "CXX COMPILER VERSION: ${CXX_COMPILER_VERSION}")

##---------------------------------------------------
## Determine build type
##--------------------------------------------------- 

if(NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release)
endif(NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)

message(STATUS "CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE} " )

if( CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX )

  ##---------------------------------------------------
  ## Set global compiler flags (if available)
  ##--------------------------------------------------- 

  include(CheckCXXCompilerFlag)
  check_cxx_compiler_flag(-Wall CXX_ACCEPTS_WALL )
  if( CXX_ACCEPTS_WALL )
    add_definitions( -Wall ) 
  endif( CXX_ACCEPTS_WALL )

  check_cxx_compiler_flag(-Wno-inline CXX_ACCEPTS_WNO-INLINE )
  if( CXX_ACCEPTS_WNO-INLINE )
    add_definitions( -Wno-inline ) 
  endif( CXX_ACCEPTS_WNO-INLINE )

  if( NOT MINGW )
    check_cxx_compiler_flag(-pthread CXX_ACCEPTS_PTHREAD )
    if( CXX_ACCEPTS_PTHREAD )
      add_definitions( -pthread ) 
    endif( CXX_ACCEPTS_PTHREAD )
  endif( NOT MINGW )

  check_cxx_compiler_flag(-fno-strict-overflow CXX_ACCEPTS_FNO-STRICT-OVERFLOW )
  if( CXX_ACCEPTS_FNO-STRICT-OVERFLOW )
    add_definitions( -fno-strict-overflow )
  endif( CXX_ACCEPTS_FNO-STRICT-OVERFLOW )

  check_cxx_compiler_flag(-pipe CXX_ACCEPTS_PIPE )
  if( CXX_ACCEPTS_PIPE )
    add_definitions( -pipe ) 
  endif( CXX_ACCEPTS_PIPE )

  # Following flag will cause warning on MacOSX, if enabled:
  #686-apple-darwin9-g++-4.0.1: -as-needed: linker input file unused because linking not done
  if( NOT APPLE)
    check_cxx_compiler_flag(-Wl,-as-needed CXX_ACCEPTS_AS_NEEDED )
    if( CXX_ACCEPTS_AS_NEEDED )
      add_definitions( -Wl,-as-needed ) 
    endif( CXX_ACCEPTS_AS_NEEDED )
  endif( NOT APPLE )

  # Display include dependencies
  # check_cxx_compiler_flag(-H CXX_ACCEPTS_H )
  # if( CXX_ACCEPTS_H )
  #  add_definitions( -H ) 
  # endif( CXX_ACCEPTS_H )

  # check_cxx_compiler_flag(-Wunreachable-code CXX_ACCEPTS_UNREACHABLE-CODE )
  # if( CXX_ACCEPTS_UNREACHABLE-CODE )
  #   add_definitions( -Wunreachable-code ) 
  # endif( CXX_ACCEPTS_UNREACHABLE-CODE )

endif( CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX )

if(MSVC)
  add_definitions( "/EHa" ) 
endif(MSVC)

## --------------------------------------------------
## Detect architecture
## --------------------------------------------------

if (UNIX AND NOT WIN32)
  if (CMAKE_SIZEOF_VOID_P MATCHES "8")
    message (STATUS "Architecture: 64bit Unix" )
    set(ATERM_FLAGS "-m64 -DAT_64BIT")
    add_definitions("-DAT_64BIT")
    # set(ARCHITECTURE "x86_64")
  endif (CMAKE_SIZEOF_VOID_P MATCHES "8")
  if (CMAKE_SIZEOF_VOID_P MATCHES "4")
    message (STATUS "Architecture: 32bit Unix" )
    set(ATERM_FLAGS "-m32")
    # set(ARCHITECTURE "i386")
  endif (CMAKE_SIZEOF_VOID_P MATCHES "4")
endif (UNIX AND NOT WIN32)

##---------------------------------------------------
## Remove "install_tools"
## install_tools contains the tools marked for symlink export 
##--------------------------------------------------- 
if(APPLE)
  if(EXISTS "${CMAKE_BINARY_DIR}/install_tools" )
    FILE(REMOVE ${CMAKE_BINARY_DIR}/install_tools )
  endif(EXISTS "${CMAKE_BINARY_DIR}/install_tools" )
endif(APPLE)


##---------------------------------------------------
## Print CMake install prefix (if any)
##--------------------------------------------------- 

message(STATUS "CMAKE_INSTALL_PREFIX: ${CMAKE_INSTALL_PREFIX}")


##---------------------------------------------------
## Print the way how libraries are built 
##--------------------------------------------------- 

option(BUILD_SHARED_LIBS "Enable/disable creation of shared libraries" ON)

## SET mCRL2 Library Directory
# Unix 
if(UNIX)
  set(MCRL2_LIB_DIR "lib/mcrl2")
endif(UNIX)

# Override MCRL2_LIB_DIR such that libraries are stored in
# bin directory, such that they can be found after an install
if(WIN32)
  set(MCRL2_LIB_DIR "bin")
endif(WIN32)

if(APPLE AND MCRL2_SINGLE_BUNDLE)
  set(MCRL2_BIN_DIR "MacOS")
else(APPLE AND MCRL2_SINGLE_BUNDLE)
  set(MCRL2_BIN_DIR "bin")
endif(APPLE AND MCRL2_SINGLE_BUNDLE)


if(BUILD_SHARED_LIBS)
  if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX) 
    if(NOT MINGW)
      check_cxx_compiler_flag(-fPIC CXX_ACCEPTS_FPIC )
      if( CXX_ACCEPTS_FPIC )
        add_definitions( -fPIC )
        set(BUILD_SHARED_LIBS_OPTION "-fPIC")  
      endif( CXX_ACCEPTS_FPIC )
    endif(NOT MINGW)
  endif( CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX)

  if(WIN32)
    if(MINGW OR MSYS)
      get_filename_component( MINGW_LIB_DIR ${CMAKE_CXX_COMPILER} PATH )

      # Install required MINGW DLLs
      install(
	FILES
        ${MINGW_LIB_DIR}/libgcc_s_dw2-1.dll
	${MINGW_LIB_DIR}/mingwm10.dll
        DESTINATION ${MCRL2_BIN_DIR} 
      )

      if  (MCRL2_ENABLE_GUI_TOOLS)
        # Install compiled wxWidgets DLLs
        # Libraries are searched for in following order:
        # 1) relative path to wxWidgets_CONFIG_EXECUTABLE
        # 2) relative path to wxWidgets_wxrc_EXECUTABLE        (not implemented)
        # 3) to given wxWidgets_LIB_DIR                   (not implemented)
        # 4) to given wxWidgets_ROOT_DIR                  (not implemented)

        if( NOT ${wxWidgets_CONFIG_EXECUTABLE} MATCHES wxWidgets_wxrc_EXECUTABLE-NOTFOUND )
          get_filename_component(MINGW_wxWidgets_LIB_DIR ${wxWidgets_CONFIG_EXECUTABLE} PATH )
          STRING(REPLACE "${MCRL2_BIN_DIR}" "lib" MINGW_wxWidgets_LIB_DIR "${MINGW_wxWidgets_LIB_DIR}" )
        endif( NOT ${wxWidgets_CONFIG_EXECUTABLE} MATCHES wxWidgets_wxrc_EXECUTABLE-NOTFOUND )

    	# Copy wxWidgets files on install
	    if(MINGW_wxWidgets_LIB_DIR)
	      install(
             DIRECTORY
                   ${MINGW_wxWidgets_LIB_DIR}/
	           DESTINATION ${MCRL2_BIN_DIR}
	           PATTERN "dll"
             )
          else(MINGW_wxWidgets_LIB_DIR)
            message( STATUS "wxWidgets DLLs cannot be deterimed for a shared build." )
            message( STATUS "Copy DLLs manually." )
	      endif(MINGW_wxWidgets_LIB_DIR)  
      endif(MCRL2_ENABLE_GUI_TOOLS )

    endif(MINGW OR MSYS)
  endif(WIN32)

else(BUILD_SHARED_LIBS)
  set(BUILD_SHARED_LIBS false)
endif(BUILD_SHARED_LIBS)
message(STATUS "BUILD_SHARED_LIBS: ${BUILD_SHARED_LIBS}")


##-----------------------------------------------------
## Set runtime path variable RPATH for install targets 
##----------------------------------------------------- 

# use, i.e. don't skip the full RPATH for the build tree
set(CMAKE_SKIP_BUILD_RPATH false)

# when building, don't use the install RPATH already
# (but later on when installing)
set(CMAKE_BUILD_WITH_INSTALL_RPATH false)

=== Makefile ===
.PHONY: all bjam install test tags clean distclean parsers mcrl2parser chiparser liblts_fsmparser doxy tex

all: bjam config.status
	$(BOOST_BUILD)

install: bjam config.status
	$(BOOST_BUILD) --install

test: bjam config.status
	$(BJAM) ./status -l300 regression-testing=yes --enable-experimental --enable-deprecated --tool-tests

clean:
	@$(RM) -r autom4te.cache core core.* tags build/bin/.jamdeps
	$(RM) -rf build/bin/* build/stage

distclean: clean
	@$(RM) -rf build/Makefile config.log config.status build/config.jam libraries/utilities/include/mcrl2/setup.h
	$(RM) -rf build/bin

ifneq ($(filter all bjam install test configure, ${MAKECMDGOALS}),)
  include build/Makefile
endif
ifeq (${MAKECMDGOALS},)
  include build/Makefile
endif

parsers: liblts_fsmparser liblts_dotparser mcrl2parser chiparser lysaparser
	cp /usr/include/FlexLexer.h build/workarounds

liblts_fsmparser:
	cd libraries/lts/source; \
	flex -Pfsm -oliblts_fsmlexer.cpp liblts_fsmlexer.ll; \
	bison -p fsm --defines=../include/mcrl2/lts/detail/liblts_fsmparser.h -o liblts_fsmparser.cpp liblts_fsmparser.yy; \
	sed -i 's+#include "liblts_fsmparser.h"+#include "mcrl2/lts/detail/liblts_fsmparser.h"+' liblts_fsmparser.cpp; \
	sed -i '/isatty/d' liblts_fsmlexer.cpp

liblts_dotparser:
	cd libraries/lts/source; \
	flex -Pdot -oliblts_dotlexer.cpp liblts_dotlexer.ll; \
	bison -p dot --defines=../include/mcrl2/lts/detail/liblts_dotparser.h -o liblts_dotparser.cpp liblts_dotparser.yy; \
	sed -i 's+#include "liblts_dotparser.h"+#include "mcrl2/lts/detail/liblts_dotparser.h"+' liblts_dotparser.cpp; \
	sed -i '/isatty/d' liblts_dotlexer.cpp

mcrl2parser:
	cd libraries/core/source; \
	flex -Pmcrl2 -omcrl2lexer.cpp mcrl2lexer.ll; \
	bison -p mcrl2 --defines=../include/mcrl2/core/detail/mcrl2parser.h -o mcrl2parser.cpp mcrl2parser.yy; \
	sed -i 's+#include "mcrl2parser.h"+#include "mcrl2/core/detail/mcrl2parser.h"+' mcrl2parser.cpp; \
	sed -i '/isatty/d' mcrl2lexer.cpp

chiparser:
	cd tools/chi2mcrl2; \
	flex -Pchi -ochilexer.cpp chilexer.ll; \
	bison -p chi --defines=chiparser.h -o chiparser.cpp chiparser.yy; \
	sed -i '/isatty/d' chilexer.cpp

lysaparser:
	cd tools/lysa2mcrl2; \
	flex -Plysa -olysalexer.cpp lysalexer.ll; \
	bison -p lysa --defines=lysaparser.h -o lysaparser.cpp lysaparser.yy; \
	sed -i '/isatty/d' lysalexer.cpp

tags:
	ctags --languages=C,C++ --recurse=yes --extra=+q --fields=+i --totals=yes .

doxy:
	@doc/doxy/generate_libref_website.sh

tex:
	@doc/tex/generate_libdocs.py

build/Makefile:
	$(error Please run configure first)

=== libraries/CMakeLists.txt ===
# Authors: Frank Stappers and Aad Mathijssen
# Copyright: see the accompanying file COPYING or copy at
# https://svn.win.tue.nl/trac/MCRL2/browser/trunk/COPYING
#
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)

# ########## Project setup ##########
project(mcrl2_monolib)
cmake_minimum_required(VERSION 2.6)

# ######### General setup ##########
include_directories(${CMAKE_SOURCE_DIR}/libraries/utilities/include )
include_directories(${CMAKE_SOURCE_DIR}/libraries/trace/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/lps/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/pbes/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/lts/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/data/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/core/include/ )
include_directories(${CMAKE_SOURCE_DIR}/libraries/process/include/)
include_directories(${CMAKE_SOURCE_DIR}/libraries/atermpp/include)
include_directories(${CMAKE_SOURCE_DIR}/build/workarounds/)
include_directories(${CMAKE_SOURCE_DIR}/build/precompile)
include_directories(${CMAKE_SOURCE_DIR}/3rd-party/aterm/include/aterm/)
include_directories(${CMAKE_SOURCE_DIR}/3rd-party/ticpp/include)
include_directories(${CMAKE_SOURCE_DIR}/3rd-party/svc/include)
include_directories(${CMAKE_SOURCE_DIR}/tools/squadt/libraries/tipi/include/)
#The following include directory is required by out-of-source builds for finding setup.h
include_directories(${CMAKE_BINARY_DIR}/libraries/utilities/include)

add_definitions("-DENABLE_SQUADT_CONNECTIVITY")

if(MINGW)
  target_link_libraries(${PROJECT_NAME}
    wsock32
    ws2_32
  )
endif(MINGW)   

if ( APPLE)
    set(CMAKE_EXE_LINKER_FLAGS "-framework Carbon ${CMAKE_EXE_LINKER_FLAGS}")
    set(CMAKE_SHARED_LINKER_FLAGS "-framework Carbon ${CMAKE_SHARED_LINKER_FLAGS}")
    set(CMAKE_MODULE_LINKER_FLAGS "-framework Carbon ${CMAKE_SHARED_LINKER_FLAGS}")
endif (APPLE)

if(MCRL2_BUILD_GUI_TOOLS)
  set(MCRL2_SIMULATOR_GUI
    ${CMAKE_SOURCE_DIR}/tools/lpsxsim/simulatorgui.cpp
  )
endif(MCRL2_BUILD_GUI_TOOLS)

add_library( ${PROJECT_NAME}
  ${mcrl2_core_src}
  ${mcrl2_data_src}
  ${mcrl2_utilities_squadt_src}
  ${mcrl2_utilities_wx_src}
  ${mcrl2_lps_src}
  ${mcrl2_lts_src}
  ${mcrl2_process_src}
  ${squadt_tipi_src}
  ${mcrl2_utilities_command_line_src}
  ${CMAKE_SOURCE_DIR}/tools/lpsxsim/simulator.cpp
  ${CMAKE_SOURCE_DIR}/tools/lpsxsim/simbase.cpp
  ${MCRL2_SIMULATOR_GUI}
)

set_source_files_properties(${CMAKE_SOURCE_DIR}/libraries/utilities/source/toolset_revision.cpp
  PROPERTIES COMPILE_DEFINITIONS MCRL2_REVISION="${SVN_REV} - ${CMAKE_BUILD_TYPE}"
)

target_link_libraries(${PROJECT_NAME}
  svc 
  ticpp
  aterm
)

if(MCRL2_USE_BOOST_INTERNAL)
  target_link_libraries(${PROJECT_NAME}
    boost
  ) 
else(MCRL2_USE_BOOST_INTERNAL)
  target_link_libraries(${PROJECT_NAME}
    ${Boost_LIBRARIES}     
  ) 
endif(MCRL2_USE_BOOST_INTERNAL)


if(MCRL2_BUILD_GUI_TOOLS)
  target_link_libraries(${PROJECT_NAME}
    ${wxWidgets_LIBRARIES}
    ${OPENGL_LIBRARY}
  )
endif(MCRL2_BUILD_GUI_TOOLS)


install(TARGETS ${PROJECT_NAME} DESTINATION ${MCRL2_LIB_DIR})

=== 3rd-party/aterm/CMakeLists.txt ===
# Authors: Frank Stappers and Aad Mathijssen
# Copyright: see the accompanying file COPYING or copy at
# https://svn.win.tue.nl/trac/MCRL2/browser/trunk/COPYING
#
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)

project(aterm)
cmake_minimum_required(VERSION 2.6)

# main target
add_library(${PROJECT_NAME}
  source/version.c
  source/idmappings.c
  source/make.c
  source/bafio.c
  source/memmgnt.c
  source/memory.c
  source/aterm.c
  source/hash.c
  source/list.c
  source/afun.c
  source/safio.c
  source/byteencoding.c
  source/byteio.c
  source/gc.c
  source/md5c.c
  source/tafio.c
)

include_directories(${CMAKE_SOURCE_DIR}/3rd-party/aterm/include/aterm)

install(TARGETS ${PROJECT_NAME} DESTINATION ${MCRL2_LIB_DIR})

=== 3rd-party/ticpp/CMakeLists.txt ===
# Authors: Frank Stappers and Aad Mathijssen
# Copyright: see the accompanying file COPYING or copy at
# https://svn.win.tue.nl/trac/MCRL2/browser/trunk/COPYING
#
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)

# ########## Project setup ##########
project(ticpp)
cmake_minimum_required(VERSION 2.6)

# ######### General setup ##########
add_definitions(-DTIXML_USE_TICPP)

# actual target:
add_library(${PROJECT_NAME}
  source/ticpp.cpp
  source/tinyxmlparser.cpp
  source/tinyxmlerror.cpp
  source/tinyxml.cpp
)

include_directories(${CMAKE_SOURCE_DIR}/3rd-party/ticpp/include)

# add install target:
install(TARGETS ${PROJECT_NAME} DESTINATION ${MCRL2_LIB_DIR})

=== build/macosx/CMakeLists.txt ===
# Authors: Frank Stappers
# Copyright: see the accompanying file COPYING or copy at
# https://svn.win.tue.nl/trac/MCRL2/browser/trunk/COPYING
#
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)

# ########## Project setup ##########
project(mac_installer)
cmake_minimum_required(VERSION 2.6)

# ######### General setup ##########

SET(MACOSX_BUNDLE_ICON_FILE mcrl2-logo.icns)

if ( MCRL2_BUILD_GUI_TOOLS )
add_executable(${PROJECT_NAME} WIN32 MACOSX_BUNDLE
  mac_installer.cpp
  ${MACOSX_BUNDLE_ICON_FILE}
)

IF (APPLE)
 SET_SOURCE_FILES_PROPERTIES(${MACOSX_BUNDLE_ICON_FILE} PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
ENDIF (APPLE)


include_directories(${CMAKE_SOURCE_DIR}/libraries/utilities/include)

if( MONO_LIB )
  target_link_libraries(${PROJECT_NAME}
    mcrl2_monolib
  )

else( MONO_LIB )
target_link_libraries(${PROJECT_NAME}
  ${wxWidgets_LIBRARIES}
)
endif( MONO_LIB )

# install target:
install(TARGETS ${PROJECT_NAME} DESTINATION ${MCRL2_BIN_DIR})

else ( MCRL2_BUILD_GUI_TOOLS)
  message( FATAL "MCRL2_BUILD_GUI_TOOLS needs to be set to TRUE to create installer")

endif ( MCRL2_BUILD_GUI_TOOLS )

=== libraries/core/CMakeLists.txt ===
# Authors: Frank Stappers and Aad Mathijssen
# Copyright: see the accompanying file COPYING or copy at
# https://svn.win.tue.nl/trac/MCRL2/browser/trunk/COPYING
#
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)

# ########## Project setup ##########
project(mcrl2_core)
cmake_minimum_required(VERSION 2.6)

# ######### Set policies ############

# ################################### 
# "core" links to some transitive 
# libraries for which the linker must
# search:
#   wxWidgets
# Therefore CMP0003 is set to NEW
# If not set, a BUILD_SHARED_LIB=TRUE
# combined with a wxWidgets build 
# raises a warning
# ###################################

if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

# ######### General setup ##########

set(mcrl2_core_src
  ${CMAKE_CURRENT_SOURCE_DIR}/source/typecheck.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/parse.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/struct_core.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/mcrl2parser.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/mcrl2lexer.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/regfrmtrans.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/print.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/messaging.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/aterm_ext.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/print_c.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/text_utility.cpp
)

set(mcrl2_core_src ${mcrl2_core_src} PARENT_SCOPE)

if( NOT MCRL2_MONO_LIB)
  include_directories(${CMAKE_SOURCE_DIR}/libraries/core/include )
  include_directories(${CMAKE_SOURCE_DIR}/libraries/data/include )
  include_directories(${CMAKE_SOURCE_DIR}/3rd-party/aterm/include/aterm/)
  include_directories(${CMAKE_SOURCE_DIR}/libraries/atermpp/include)
  include_directories(${CMAKE_SOURCE_DIR}/libraries/utilities/include)
  include_directories(${CMAKE_SOURCE_DIR}/build/workarounds/)
  
  # actual target:
  add_library(${PROJECT_NAME}
    ${mcrl2_core_src}
  )
  
  target_link_libraries(${PROJECT_NAME}
    aterm
  )
  
  # add install target:
  install(TARGETS ${PROJECT_NAME} DESTINATION ${MCRL2_LIB_DIR})

endif( NOT MCRL2_MONO_LIB)

=== libraries/data/CMakeLists.txt ===
# Authors: Frank Stappers and Aad Mathijssen
# Copyright: see the accompanying file COPYING or copy at
# https://svn.win.tue.nl/trac/MCRL2/browser/trunk/COPYING
#
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)

# ########## Project setup ##########
project(mcrl2_data)
cmake_minimum_required(VERSION 2.6)

# ######### General setup ##########

#jitty.c requires DL_LIBS
if(UNIX)
  LINK_LIBRARIES(${CMAKE_THREAD_LIBS} ${CMAKE_DL_LIBS})
  set(COMP_REWRITERS 
   ${CMAKE_CURRENT_SOURCE_DIR}/source/detail/rewrite/jittyc.cpp
   ${CMAKE_CURRENT_SOURCE_DIR}/source/detail/rewrite/innerc.cpp
  )
endif(UNIX)

set(mcrl2_data_src
 ${CMAKE_CURRENT_SOURCE_DIR}/source/implementations.cpp
 ${CMAKE_CURRENT_SOURCE_DIR}/source/detail/rewrite/with_prover.cpp
 ${CMAKE_CURRENT_SOURCE_DIR}/source/detail/rewrite/inner.cpp
 ${CMAKE_CURRENT_SOURCE_DIR}/source/detail/rewrite/jitty.cpp
 ${CMAKE_CURRENT_SOURCE_DIR}/source/detail/rewrite/rewrite.cpp
 ${COMP_REWRITERS}
)

set(mcrl2_data_src ${mcrl2_data_src} PARENT_SCOPE)

if( NOT MCRL2_MONO_LIB)

  include_directories(${CMAKE_SOURCE_DIR}/libraries/data/include)
  include_directories(${CMAKE_SOURCE_DIR}/libraries/core/include)
  include_directories(${CMAKE_SOURCE_DIR}/libraries/atermpp/include)
  include_directories(${CMAKE_SOURCE_DIR}/libraries/utilities/include)
  include_directories(${CMAKE_SOURCE_DIR}/3rd-party/aterm/include/aterm)
  include_directories(${CMAKE_SOURCE_DIR}/build/workarounds)
  include_directories(${CMAKE_SOURCE_DIR}/build/precompile)
  #The following include directory is required by out-of-source builds for finding setup.h
  include_directories(${CMAKE_BINARY_DIR}/libraries/utilities/include)

  add_library(${PROJECT_NAME}
    ${mcrl2_data_src}
  )

  target_link_libraries(${PROJECT_NAME}
    mcrl2_core
  )

  # add install target:
  install(TARGETS ${PROJECT_NAME} DESTINATION ${MCRL2_LIB_DIR})
endif(NOT MCRL2_MONO_LIB)

=== libraries/lps/CMakeLists.txt ===
# Authors: Frank Stappers and Aad Mathijssen
# Copyright: see the accompanying file COPYING or copy at
# https://svn.win.tue.nl/trac/MCRL2/browser/trunk/COPYING
#
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)

# ########## Project setup ##########
project(mcrl2_lps)
cmake_minimum_required(VERSION 2.6)

# ######### General setup ##########

include_directories(${CMAKE_SOURCE_DIR}/libraries/lps/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/data/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/core/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/process/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/utilities/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/atermpp/include)
include_directories(${CMAKE_SOURCE_DIR}/3rd-party/aterm/include/aterm)
include_directories(${CMAKE_SOURCE_DIR}/build/workarounds)
include_directories(${CMAKE_SOURCE_DIR}/build/precompile)

set(mcrl2_lps_src
  ${CMAKE_CURRENT_SOURCE_DIR}/source/implementations.cpp
)
set(mcrl2_lps_src ${mcrl2_lps_src} PARENT_SCOPE)

if( NOT MCRL2_MONO_LIB )

  add_library(${PROJECT_NAME}
    ${mcrl2_lps_src}
  )

  target_link_libraries(${PROJECT_NAME}
    mcrl2_data
    mcrl2_process
  )

  # add install target:
  install(TARGETS ${PROJECT_NAME} DESTINATION ${MCRL2_LIB_DIR})
endif( NOT MCRL2_MONO_LIB )

=== libraries/lts/CMakeLists.txt ===
# Authors: Frank Stappers and Aad Mathijssen
# Copyright: see the accompanying file COPYING or copy at
# https://svn.win.tue.nl/trac/MCRL2/browser/trunk/COPYING
#
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)

# ########## Project setup ##########
project(mcrl2_lts)
cmake_minimum_required(VERSION 2.6)

# ######### General setup ##########

include_directories(${CMAKE_SOURCE_DIR}/libraries/lts/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/trace/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/lps/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/data/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/core/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/utilities/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/atermpp/include)
include_directories(${CMAKE_SOURCE_DIR}/build/workarounds)
include_directories(${CMAKE_SOURCE_DIR}/build/precompile)
include_directories(${CMAKE_SOURCE_DIR}/3rd-party/aterm/include/aterm)
include_directories(${CMAKE_SOURCE_DIR}/3rd-party/svc/include)

set(mcrl2_lts_src
  ${CMAKE_CURRENT_SOURCE_DIR}/source/liblts_fsmlexer.cpp
#  ${CMAKE_CURRENT_SOURCE_DIR}/source/liblts_fsmlexer.h
#  ${CMAKE_CURRENT_SOURCE_DIR}/source/liblts_fsmlexer.ll
#  ${CMAKE_CURRENT_SOURCE_DIR}/source/liblts_fsmparser.h
#  ${CMAKE_CURRENT_SOURCE_DIR}/source/liblts_dotparser.h
  ${CMAKE_CURRENT_SOURCE_DIR}/source/liblts_fsmparser.cpp
#  ${CMAKE_CURRENT_SOURCE_DIR}/source/liblts_dotlexer.ll
  ${CMAKE_CURRENT_SOURCE_DIR}/source/liblts_dotparser.cpp
#  ${CMAKE_CURRENT_SOURCE_DIR}/source/liblts_fsmparser.yy
#  ${CMAKE_CURRENT_SOURCE_DIR}/source/liblts_dotparser.yy
  ${CMAKE_CURRENT_SOURCE_DIR}/source/liblts_dotlexer.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/liblts_scc.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/liblts_sim.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/liblts_aut.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/liblts_det.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/liblts_svc.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/liblts_bisim.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/sim_hashtable.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/liblts_eq.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/liblts_dot.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/liblts.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/liblts_bcg.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/liblts_tau_star.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/tree_set.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/liblts_fsm.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/exploration.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/lps2lts_lts.cpp
)
set(mcrl2_lts_src ${mcrl2_lts_src} PARENT_SCOPE)

if(NOT MCRL2_MONO_LIB)
  # actual target:
  add_library(${PROJECT_NAME}
    ${mcrl2_lts_src}
  )

  target_link_libraries(${PROJECT_NAME}
    mcrl2_data
    mcrl2_lps
    svc
  )

  # add install target:
  install(TARGETS ${PROJECT_NAME} DESTINATION ${MCRL2_LIB_DIR})
endif( NOT MCRL2_MONO_LIB )

=== libraries/process/CMakeLists.txt ===
# Authors: Jeroen Keiren
# Copyright: see the accompanying file COPYING or copy at
# https://svn.win.tue.nl/trac/MCRL2/browser/trunk/COPYING
#
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)

# ########## Project setup ##########
project(mcrl2_process)
cmake_minimum_required(VERSION 2.6)

# ######### General setup ##########

include_directories(${CMAKE_SOURCE_DIR}/libraries/core/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/data/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/process/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/lps/include)
include_directories(${CMAKE_SOURCE_DIR}/3rd-party/aterm/include/aterm/)
include_directories(${CMAKE_SOURCE_DIR}/libraries/atermpp/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/utilities/include)
include_directories(${CMAKE_SOURCE_DIR}/build/workarounds/)

set(mcrl2_process_src
  ${CMAKE_CURRENT_SOURCE_DIR}/source/alphabet_reduction.cpp
)

set(mcrl2_process_src ${mcrl2_process_src} PARENT_SCOPE)

if( NOT MCRL2_MONO_LIB)
  # actual target:
  add_library(${PROJECT_NAME}
    ${mcrl2_process_src}
  )
  
  target_link_libraries(${PROJECT_NAME}
    mcrl2_core
    mcrl2_data
  )
  
  # add install target:
  install(TARGETS ${PROJECT_NAME} DESTINATION ${MCRL2_LIB_DIR})

endif( NOT MCRL2_MONO_LIB)

=== libraries/utilities/CMakeLists.txt ===
# Authors: Frank Stappers and Aad Mathijssen
# Copyright: see the accompanying file COPYING or copy at
# https://svn.win.tue.nl/trac/MCRL2/browser/trunk/COPYING
#
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)

# ##################################
# ## mcrl2_utilities_command_line ##
# ##################################

project(mcrl2_utilities_command_line)
cmake_minimum_required(VERSION 2.6)

set(mcrl2_utilities_command_line_src
  ${CMAKE_CURRENT_SOURCE_DIR}/source/command_line_interface.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/toolset_revision.cpp
)

set(mcrl2_utilities_command_line_src ${mcrl2_utilities_command_line_src}  PARENT_SCOPE)

set_source_files_properties(${CMAKE_CURRENT_SOURCE_DIR}/source/toolset_revision.cpp
  PROPERTIES COMPILE_DEFINITIONS MCRL2_REVISION="${SVN_REV} - ${CMAKE_BUILD_TYPE}"
)

if( NOT MCRL2_MONO_LIB )
  include_directories(${CMAKE_SOURCE_DIR}/libraries/utilities/include)

  add_library(${PROJECT_NAME}
    ${mcrl2_utilities_command_line_src}
  )
  
  if(MCRL2_USE_BOOST_INTERNAL)
    target_link_libraries(${PROJECT_NAME}
      boost
    ) 
  else(MCRL2_USE_BOOST_INTERNAL)
    target_link_libraries(${PROJECT_NAME}
      ${Boost_LIBRARIES}
    )
  endif(MCRL2_USE_BOOST_INTERNAL)
  
  install(TARGETS ${PROJECT_NAME} DESTINATION ${MCRL2_LIB_DIR})
endif( NOT MCRL2_MONO_LIB )

# ##############################
# ##  mcrl2_utilities_squadt  ##
# ##############################

  
project(mcrl2_utilities_squadt)
cmake_minimum_required(VERSION 2.6)

set(mcrl2_utilities_squadt_src
  ${CMAKE_CURRENT_SOURCE_DIR}/source/squadt_interface.cpp
)

set(mcrl2_utilities_squadt_src ${mcrl2_utilities_squadt_src} PARENT_SCOPE)  

if( NOT MCRL2_MONO_LIB )

  include_directories(${CMAKE_SOURCE_DIR}/tools/squadt/libraries/tipi/include)
  include_directories(${CMAKE_SOURCE_DIR}/libraries/utilities/include)
  
  add_library(${PROJECT_NAME}
    ${mcrl2_utilities_squadt_src}
  )
  
  add_definitions("-DENABLE_SQUADT_CONNECTIVITY")
  
  target_link_libraries(${PROJECT_NAME}
    squadt_tipi
  )
  
  if(MINGW)
    target_link_libraries(${PROJECT_NAME}
      wsock32
      ws2_32
    )
  endif(MINGW)   
  
  if ( APPLE)
      set(CMAKE_EXE_LINKER_FLAGS "-framework Carbon ${CMAKE_EXE_LINKER_FLAGS}")
      set(CMAKE_SHARED_LINKER_FLAGS "-framework Carbon ${CMAKE_SHARED_LINKER_FLAGS}")
      set(CMAKE_MODULE_LINKER_FLAGS "-framework Carbon ${CMAKE_SHARED_LINKER_FLAGS}")
  endif (APPLE)
  
  # add install target:
  install(TARGETS ${PROJECT_NAME} DESTINATION ${MCRL2_LIB_DIR})

endif( NOT MCRL2_MONO_LIB )

# ##############################
# ##    mcrl2_utilities_wx    ##
# ##############################

if(MCRL2_BUILD_GUI_TOOLS)

project(mcrl2_utilities_wx)
cmake_minimum_required(VERSION 2.6)

set(mcrl2_utilities_wx_src
  ${CMAKE_CURRENT_SOURCE_DIR}/source/spinctrlfloat.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/colorbutton.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/font_renderer.cpp
)

set(mcrl2_utilities_wx_src ${mcrl2_utilities_wx_src} PARENT_SCOPE)

if( NOT MCRL2_MONO_LIB )

  include_directories(${CMAKE_SOURCE_DIR}/libraries/utilities/include)
  include_directories(${CMAKE_SOURCE_DIR}/build/precompile)
  
  add_library(${PROJECT_NAME}
    ${mcrl2_utilities_wx_src}
  )
  
  target_link_libraries(${PROJECT_NAME}
    ${wxWidgets_LIBRARIES}
    ${OPENGL_LIBRARY}
  )
  
  # add install target:
  install(TARGETS ${PROJECT_NAME} DESTINATION ${MCRL2_LIB_DIR})

endif( NOT MCRL2_MONO_LIB )

endif(MCRL2_BUILD_GUI_TOOLS)

=== debian/changelog ===
mcrl2 (201007~rc1-1) unstable; urgency=low

  * New upstream release; using this release candidate for Squeeze
    as recommended by upstream.
  * debian/control: 
    - Bumped standards version to 3.9.1; no changes required.
  * debian/copyright:
    - Inserted the BSD license verbatim instead of pointing to
      /usr/share/common-licenses/BSD which is soon to be removed.
  * debian/menu:
    - Replaced menu item for SQuADT by one for mCRL2 GUI.
  * debian/rules:
    - Added MCRL2_ suffixes to the build flags because this has been
      changed upstream.

 -- Paul van Tilburg <paulvt@debian.org>  Tue, 03 Aug 2010 12:49:57 +0200

=== debian/control ===
Source: mcrl2
Section: math
Priority: extra
Maintainer: Paul van Tilburg <paulvt@debian.org>
Build-Depends: debhelper (>= 5), cmake, libboost1.42-dev, libboost-date-time1.42-dev, libboost-filesystem1.42-dev, libboost-graph1.42-dev, libboost-program-options1.42-dev, libboost-regex1.42-dev, libboost-signals1.42-dev, libboost-system1.42-dev, libboost-test1.42-dev, libboost-thread1.42-dev, libwxgtk2.8-dev (>= 2.8.4), libglu1-mesa-dev (>= 7.0.1)
Standards-Version: 3.9.1
Homepage: http://www.mcrl2.org/
Vcs-Browser: https://svn.win.tue.nl/viewcvs/MCRL2/packaging/mcrl2/trunk/
Vcs-Svn: https://svn.win.tue.nl/repos/MCRL2/packaging/mcrl2/trunk/

Package: mcrl2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: the mCRL2 formal specification language toolset
 mCRL2 stands for micro Common Representation Language 2.  It is a
 specification language that can be used to specify and analyse the
 behaviour of distributed systems and protocols and is the successor to
 muCRL.  Using its accompanying toolset, systems can be analysed and
 verified automatically.
 .
 This toolset supports a collection of tools for linearisation, simulation,
 state-space exploration and generation and tools to optimise and analyse
 specifications.  Moreover, state spaces can be manipulated, visualised and
 analysed.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
#
# Makefile to build the mCRL2 package using debhelper.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

CFLAGS = -Wall
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS_RELEASE = -O0 -g -DNDEBUG $(CFLAGS)
	CFLAGS_DEBUG   = -O0 -g $(CFLAGS)
else 
	CFLAGS_RELEASE = -O2 -g -DNDEBUG $(CFLAGS)
	CFLAGS_DEBUG   = -O2 -g $(CFLAGS)
endif

BUILD_TYPE = Release
ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	BUILD_TYPE = Debug
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))  
    MAKEFLAGS += -j$(NUMJOBS)
endif

BUILD_FLAGS = -DCMAKE_INSTALL_PREFIX="/usr" \
              -DCMAKE_INSTALL_RPATH="/usr/lib/mcrl2" \
	      -DCMAKE_BUILD_TYPE="$(BUILD_TYPE)" \
	      -DCMAKE_C_FLAGS_RELEASE="$(CFLAGS_RELEASE)" \
	      -DCMAKE_C_FLAGS_DEBUG="$(CFLAGS_DEBUG)" \
	      -DCMAKE_VERBOSE_MAKEFILE="ON" \
	      -DMCRL2_ENABLE_EXPERIMENTAL="OFF" \
	      -DMCRL2_ENABLE_DEPRECATED="OFF"	 \
	      -DMCRL2_ENABLE_TEST_TARGETS="OFF" \
	      -DMCRL2_USE_BOOST_INTERNAL="OFF" \
	      -DMCRL2_MAN_PAGES="OFF" \
	      -DMCRL2_BUILD_IN_SOURCE="ON"
ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
	BUILD_FLAGS += -DCMAKE_SYSTEM_NAME=$(shell dpkg-architecture -qDEB_BUILD_ARCH_OS) \
		       -DCMAKE_SYSTEM_PROCESSOR=$(shell dpkg-architecture -qDEB_BUILD_ARCH_CPU) \
		       -DCMAKE_C_COMPILER=$(DEB_BUILD_GNU_TYPE)-gcc
endif

SRC	:= $(CURDIR)
BUILD	:= $(CURDIR)/debian/build
TARGET	:= $(CURDIR)/debian/mcrl2

configure: configure-stamp

configure-stamp:
	dh_testdir
	[ -d $(BUILD) ] || mkdir $(BUILD)
	cd $(BUILD) && \
	  cmake $(BUILD_FLAGS) $(CURDIR) 
	touch $@

build: build-stamp

build-stamp: configure
	dh_testdir
	$(MAKE) -C $(BUILD) $(MAKEFLAGS)
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -rf $(BUILD)
	rm -f configure-stamp build-stamp 
	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs
	$(MAKE) -C $(BUILD) install DESTDIR=$(TARGET)
	# Generate and install the man pages.
	export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:$(BUILD)/usr/lib/mcrl2
	(cd $(BUILD) && cmake $(BUILD_FLAGS) $(CURDIR) -DMAN_PAGES="on")
	$(MAKE) -C $(BUILD) $(MAKEFLAGS)
	$(MAKE) -C $(BUILD) install DESTDIR=$(TARGET)

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs 
	dh_installdocs
	dh_installexamples
	dh_installmenu
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_makeshlibs -V --exclude=/usr/lib/mcrl2
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

=== debian/watch ===
# mCRL2 watch file

version=3
http://mcrl2.org/mcrl2/wiki/index.php/Download .*mcrl2-(\d+)-src\.tar\.bz2.*
